#!/usr/bin/perl
###
$Period=1;
$List=20;
$DirLock=1;
###
&FileCheck;
&PrintScript;
###
use Encode;
use Encode::Guess qw/euc-jp shift-jis/;
###
open(LOCK,"lock.dat");
flock(LOCK,2);
&ListUpdate;
if(!-s("$Dir/d1.dat")){#}
	&ScriptUpdate(0,1);
}elsif(!-s("$Dir/d0.dat")){#}
	&ScriptUpdate(1,1);
}
close(LOCK);
exit;
###
sub FileCheck{
	my(@tmp,$t);
	@tmp=split(/\//,$ENV{'HTTP_REFERER'},4);
	$Dir=$tmp[2];
	&PrintError if(!$Dir || $Dir=~/^\./);
	$Dir="data/$Dir";
	if(!-e($Dir)){
		&PrintError if($DirLock);
		mkdir($Dir,0755);
		foreach $t(("d","w")){
			for(0..1){
				open(FILE,"+>$Dir/$t$_.dat");
				close(FILE);
				chmod(0600,"$Dir/$t$_.dat");
			}
			open(FILE,"+>$Dir/$t.js");
			close(FILE);
			chmod(0600,"$Dir/$t.js");
		}
	}
}
###
sub ListUpdate{
	my($domain,$path,@tmp,$fn,@word,$reset);
	@tmp=split(/\//,&UrlDecode($ENV{'QUERY_STRING'}),4);
	$domain=$tmp[2];
	$path=$tmp[3];
	$path=~s/%25/%/g;
	return if($domain=~/['<>\\]/);
	$domain='-' if(!$domain);
	$domain='+' if("data/$domain" eq $Dir);
	if(-M("$Dir/d0.dat")>-M("$Dir/d1.dat")){
		$fn=1;
		if(-M("$Dir/d0.dat")>$Period){
			&ScriptUpdate(1);
			$fn=0;
			$reset=1;
		}
	}else{
		$fn=0;
		if(-M("$Dir/d1.dat")>$Period){
			&ScriptUpdate(0);
			$fn=1;
			$reset=1;
		}
	}
	undef(%Domain);
	undef(%Word);
	if($reset){
		open(FILE,"+>$Dir/d$fn.dat");
		close(FILE);
		open(FILE,"+>$Dir/w$fn.dat");
		close(FILE);
	}
	do("$Dir/d$fn.dat");
	$Domain{$domain}++;
	open(FILE,"+>$Dir/d$fn.dat");
	foreach(keys(%Domain)){
		print FILE "\$Domain{'$_'}=".$Domain{$_}.";\n";
	}
	close(FILE);
	@word=&SearchWord($domain,$path);
	if(@word){
		do("$Dir/w$fn.dat");
		foreach(@word){
			$Word{$_}++;
		}
		open(FILE,"+>$Dir/w$fn.dat");
		foreach(keys(%Word)){
			print FILE "\$Word{'$_'}=".$Word{$_}.";\n";
		}
		close(FILE);
	}
}
###
sub ScriptUpdate{
	my($fn,$k,$script,$object,$ref,$key,@member);
	$fn=shift;
	undef(%Domain);
	undef(%Word);
	do("$Dir/d$fn.dat");
	do("$Dir/w$fn.dat");
	foreach $key(('Domain','Word')){
		undef(@member);
		$ref=eval("\\\%$key");
		foreach(sort {$$ref{$b} <=> $$ref{$a}} keys(%$ref)){
			last if($#member>$List-2);
			push(@member,"'$_':".$$ref{$_});
		}
		$obj=join(',',@member);
		$script="data['$key']={$obj};\n";
		$k=lc(substr($key,0,1));
		open(FILE,"+>$Dir/$k.js");
		print FILE $script;
		close(FILE);
	}
}
###
sub SearchWord{
	my($domain,$path,$key,$str,$code,@word,@query);
	$domain=shift;
	$path=shift;
	return if($domain!~/\.google\./);
	return if($path!~/\?/);
	@query=split(/[\?\&]/,$path);
	shift(@query);
	foreach(@query){
		if(/q=(.+)/){
			$str=&UrlDecode($1);
			$code=guess_encoding($str);
			Encode::from_to($str,$code,'utf-8') if(ref($code));
			$str=~s/'/ /g;
			$str=~s/　/ /g;
			$str=~s/\\/&#92;/g;
			@word=split(/ +/,$str);
			last;
		}
	}
	return(@word);
}
###
sub UrlDecode{
	my($str);
	$str=$_[0];
	$str=~tr/+/ /;
	$str=~s/%([0-9A-Fa-f][0-9A-Fa-f])/pack("H2",$1)/eg;
	return($str);
}
###
sub PrintScript{
	print "content-type:text/javascript\n\n";
	print "var data=new Array();\n";
	foreach(('d','w')){
		open(FILE,"$Dir/$_.js");
		print <FILE>;
		close(FILE);
	}
	open(FILE,"script.js");
	print <FILE>;
	close(FILE);
	close(STDOUT);
	close(STDERR);
}
###
sub PrintError{
	print "content-type:text/javascript\n\n";
	exit;
}
###

